routes/web.php
<?php

use Illuminate\Support\Facades\Route;

use App\Http\Controllers\CompaniesController;
use App\Http\Controllers\EmployeesController;
use App\Http\Controllers\AuthController;
use App\Http\Controllers\ItemsController;
use App\Http\Controllers\SellController;
use App\Http\Controllers\SellSummaryController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('lang/{lang}', ['as' => 'lang.switch', 'uses' => 'App\Http\Controllers\LanguageController@switchLang']);

Auth::routes(['register' => false, 'reset' => false]);

Route::group(['middleware' => 'auth', 'checktoken'], function () {
    Route::get('/', [CompaniesController::class, 'index']); 
    Route::get('home', [CompaniesController::class, 'index']); 

    Route::get('/data-companies', [CompaniesController::class, 'dataCompanies']);

    Route::resource('companies', CompaniesController::class);

    Route::get('company/destroy/{id}', [CompaniesController::class, 'destroy']);


    Route::get('/data-employees', [EmployeesController::class, 'dataEmployees']);

    Route::resource('employees', EmployeesController::class);

    Route::get('employee/destroy/{id}', [EmployeesController::class, 'destroy']);


    Route::resource('items', ItemsController::class);

    Route::get('item/destroy/{id}', [ItemsController::class, 'destroy']);


    Route::resource('sell', SellController::class);

    Route::get('sell/destroy/{id}', [SellController::class, 'destroy']);

    Route::get('store-item-price/{id}', [SellController::class, 'storeItemPrice']);

    Route::resource('sell-summary', SellSummaryController::class);
});

app/Http/Controllers/CompaniesController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Redirect;
use App\Models\Companies;
use App\Models\Employees;
use App\Models\Timezone;
use App\Mail\NewCompanyMail;
use App\Jobs\NewCompanyMailJob;
use App\Http\Requests\StoreCompanyRequest;
use App\Http\Traits\TimezoneTrait;
use App\Http\Traits\CompaniesTrait;

class CompaniesController extends Controller
{
    use TimezoneTrait;
    use CompaniesTrait;
    
    public function index(Request $request)
    {
        if(!empty($request->timezone)){
            $this->setTimezone($request->timezone);
        }

        $timezones = Timezone::Orderby('offset')->get();

        if($request->ajax()){
            $companies_datatable = $this->setCompaniesTable();

            return $companies_datatable;
        }
        return view('companies.companies-index', compact('timezones'));
    }

    public function create()
    {
        return view('companies.company-create');
    }

    public function store(StoreCompanyRequest $request)
    {
        if ($request->hasfile('filename')) {
            $image = $this->handleUploadedImage($request);
            $this->createCompany($request, $image);
        }
        else {
            $this->createCompany($request);
        }

        //send email notification
        NewCompanyMailJob::dispatch();

        return Redirect::to('/companies')->with('success', 'null');
    }

    public function show(Companies $company)
    {
        $employees = Employees::where('company', '=', $company->id)->get();

        return view('companies.company-detail', compact('company', 'employees'));
    }

    public function edit(Companies $company)
    {
        return view('companies.company-edit', compact('company'));
    }

    public function update(StoreCompanyRequest $request, $id)
    {
        $company = Companies::find($id);

        if ($request->hasfile('filename')) {
            $image = $this->handleUploadedImage($request);
            $this->updateCompany($request, $id, $image);
            $this->deleteLogo($company->logo);
        }
        else {
            $this->updateCompany($request, $id, null, false, $company->logo);
        }

        return Redirect::route('companies.show', $id)->with('success', 'null');

    }

    public function destroy($id)
    {
        $data = Companies::findOrFail($id);
        $this->deleteLogo($data->logo);
        $data->delete();
        
        return Redirect::to('/companies');
    }
}

resources/views/companies/companies-index.blade.php
@extends('adminlte::page')

@section('title', trans('text.Companies List'))

@section('content_header')
    <h1>{{ trans('text.Companies List') }}</h1>
@stop

@section('content')<!doctype html>
    <html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
    <hr>
    <div class="container">
        <a href="{{ route('companies.create')}}" class="btn btn-success">{{ trans('text.Add') }} {{ trans('text.Company') }}</a>
    </div>
    <br/>

    <div class="container">
        <div class="row">
            <div class="col-md-4">
                <select data-column="5" class="form-control filter-select" name="timezone" id="timezone">
                    <option value="">{{ trans('text.Timezone') }}...</option>
                    @foreach($timezones as $timezone)
                        @if(session('timezone_id') == $timezone->id)
                            <option value="{{ $timezone->id }}" selected>{{ $timezone->name }} ({{ $timezone->offset }})</option>
                        @else
                            <option value="{{ $timezone->id }}">{{ $timezone->name }} ({{ $timezone->offset }})</option>
                        @endif
                    @endforeach
                </select>
            </div>
            <div class="col-md-1">
                <button type="button" name="filter" id="filter" class="btn btn-primary">Filter</button>
            </div>
        </div>
        <table class="table table-bordered" id="company_table">
            <thead>
                <tr>
                    <th>No.</th>
                    <th>{{ trans('text.Logo') }}</th>
                    <th>{{ trans('text.Name') }}</th>
                    <th>{{ trans('text.Email') }}</th>
                    <th>{{ trans('text.Website') }}</th>
                    <th>{{ trans('text.createdAt') }}</th>
                    <th width="40%">{{ trans('text.Action') }}</th>
                </tr>
            </thead>
            <tbody></tbody>
            <tfoot>
                <tr>
                    <td></td>
                    <td></td>
                    <td>
                        <input type="text" data-column="2" placeholder="Name...." class="form-control filter-input">
                    </td>
                    <td>
                        <input type="text" data-column="3" placeholder="Email...." class="form-control filter-input">
                    </td>
                    <td>
                        <input type="text" data-column="4" placeholder="Website...." class="form-control filter-input">
                    </td>
                    <td></td>
                    <td></td>
                </tr>
            </tfoot>
        </table>
    </div>

    <div id="confirmModal" class="modal fade" role="dialog">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h3 class="modal-title">{{ trans('text.Confirmation') }}</h3>
                    <button type="button" class="close" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
                    <p align="center" style="margin:0;">{{ trans('text.deleteConf') }}</p>
                </div>
                <div class="modal-footer">
                    <button type="button" name="ok_button" id="ok_button" class="btn btn-danger">OK</button>
                    <button type="button" class="btn btn-default" data-dismiss="modal">{{ trans('text.Cancel') }}</button>
                </div>
            </div>
        </div>
    </div>
@stop

@section('css')
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
    <link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/1.10.25/css/dataTables.bootstrap4.min.css">
@stop

@section('js')
    <script> console.log('Hi!'); </script>
    <script src="https://code.jquery.com/jquery-3.6.0.min.js" integrity="sha256-/xUj+3OJU5yExlq6GSYGSHk7tPXikynS7ogEvDej/m4=" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM" crossorigin="anonymous"></script>
    <script type="text/javascript" src="https://cdn.datatables.net/1.10.25/js/jquery.dataTables.min.js"></script>
    <script type="text/javascript" src="https://cdn.datatables.net/1.10.25/js/dataTables.bootstrap4.min.js"></script>
    <script>
        $(document).ready(function(){

            load_data();

            function load_data(timezone = ''){
                var t = $('#company_table').DataTable({
                    processing: true,
                    serverSide: true,
                    bLengthChange: false,
                    ajax: {
                        url: "{{ route('companies.index') }}",
                        data: {timezone:timezone}
                    },
                    columns: [
                        {
                            data: 'rownum',
                            name: 'rownum'
                        },
                        {
                            data: 'image',
                            name: 'image',
                            render: function( data, type, full, meta ) {
                                return "<img src=\"" + data + "\" style=\"width:200px;object-fit: cover;\"/>";
                            }
                        },
                        {
                            data: 'name',
                            name: 'name'
                        },
                        {
                            data: 'email',
                            name: 'email'
                        },
                        {
                            data: 'website',
                            name: 'website'
                        },
                        {
                            data: 'created_at',
                            name: 'created_at',
                        },
                        {
                            data: 'action',
                            name: 'action',
                            orderable: false
                        }
                    ],
                    "columnDefs": [ {
                        "searchable": false,
                        "orderable": false,
                        "targets": [0, 1]
                    } ],
                    "order": [[ 2, 'asc' ]]
                });

                $('.filter-input').keyup(function(){
                    t.column( $(this).data('column'))
                        .search($(this).val())
                        .draw();
                });

                t.on( 'order.dt search.dt', function () {
                    t.column(0, {search:'applied', order:'applied'}).nodes().each( function (cell, i) {
                        cell.innerHTML = i+1;
                    } );
                } ).draw();
            };

            $('#filter').click(function() {
                var timezone = $('#timezone').val();
                if(timezone != ''){
                    $('#company_table').DataTable().destroy();
                    load_data(timezone);
                };
            });

            var company_id;

            $(document).on('click', '.delete', function(){
                company_id = $(this).attr('id');
                $('#confirmModal').modal('show');
            });

            $('#ok_button').click(function(){
                $.ajax({
                    url:"company/destroy/"+company_id,
                    success:function(data) {
                        setTimeout(function(){
                            $('#confirmModal').modal('hide');
                            $('#company_table').DataTable().ajax.reload();
                            alert('Data Deleted');
                        }, 2000);
                    }
                })
            });
        });
    </script>
@stop

resources/views/companies/company-create.blade.php
<!-- <link href="{{ asset('css/style.css') }}" rel="stylesheet"> -->
@extends('adminlte::page')

@section('title', trans('text.AddCompany'))

@section('content_header')
    <h1>{{ trans('text.AddCompany') }}</h1>
@stop

@section('content')
    <html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
    <div class="container">
    <div class="row background">
        <div class="container">
            <div class="row">
                <div class="col-md-12">
                    <form method="post" action="{{ route('companies.store')}}" enctype="multipart/form-data">
                        {{csrf_field()}}
                        <div class="row mt-2">
                            <div class="col-md-2 text-left card-caption-home">{{ trans('text.Name') }}</div>
                            <div class="col-md-8">
                                <input class="form-control" type="text" name="name"/>
                            </div>
                        </div>
                        
                        <div class="row mt-2">
                            <div class="col-md-2 text-left card-caption-home">{{ trans('text.Email') }}</div>
                            <div class="col-md-8">
                                <input class="form-control" type="text" name="email" />
                            </div>
                        </div>
                        
                        <div class="row mt-2">
                            <div class="col-md-2 text-left card-caption-home">{{ trans('text.Website') }}</div>
                            <div class="col-md-8">
                                <input class="form-control" type="text" name="website" />
                            </div>
                        </div>

                        <div class="row mt-2">
                            <div class="col-md-2 text-left card-caption-home">{{ trans('text.Domain') }}</div>
                            <div class="col-md-8">
                                <input class="form-control" type="text" name="domain" />
                            </div>
                        </div>

                        <div class="row mt-2">
                            <div class="col-md-2 text-left card-caption-home">{{ trans('text.Logo') }}</div>
                            <div class="col-md-8">
                                <input type="file" name="filename" class="form-control">
                                <label>{{ trans('text.maxSize') }}: 2MB <br/> {{ trans('text.minDim') }}: 100 x 100 px</label>
                            </div>
                        </div>
                        <div class="row mt-2">
                            <div class="col-md-2 text-left"></div>
                            <div class="col-md-8">
                                <button type="submit" class="btn btn-success" style="margin-top:12px"><i class="glyphicon glyphicon-check"></i>{{ trans('text.Add') }}</button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>

@stop

@section('css')
    <link rel="stylesheet" href="/css/admin_custom.css">
@stop

@section('js')
    <script> console.log('Hi!'); </script>
@stop

resources/views/companies/company-detail.blade.php
@extends('adminlte::page')

@section('title', trans('text.Company Detail'))

@section('content_header')
    <h1>{{ trans('text.Company Detail') }}</h1>
@stop

@section('content')<!doctype html>
    <html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
    <a href="{{route('companies.edit', $company->id)}}" class="btn btn-primary"><i class="fa fa-edit"></i> {{ trans('text.Edit') }}</a>
    <button class="btn btn-danger" data-toggle="modal" data-target="#Modal"><i class="fa fa-trash"></i> {{ trans('text.Delete') }}</button>
    <div class="modal fade" id="Modal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true" align="left">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="sub-title" id="exampleModalLabel">{{ trans('text.Confirmation') }}</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    {{ trans('text.deleteConf') }}
                </div>
                <div class="modal-footer">
                    <a href="{{ URL('/company/destroy/'.$company->id) }}" type="button" class="btn btn-danger">OK</a>
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">{{ trans('text.Cancel') }}</button>
                </div>
            </div>
        </div>
    </div>

    <table style="width:100%">
        <tr>
            <th>{{ trans('text.Name') }}</th>
            <td>{{$company->name}}</td>
        </tr>
        <tr>
            <th>{{ trans('text.Email') }}</th>
            <td>{{$company->email}}</td>
        </tr>
        <tr>
            <th>{{ trans('text.Website') }}</th>
            <td>{{$company->website}}</td>
        </tr>
        <tr>
            <th>{{ trans('text.Domain') }}</th>
            <td>{{$company->domain}}</td>
        </tr>
        <tr>
            <th>{{ trans('text.Logo') }}</th>
            <td><img src="{{ asset('storage/'.$company->logo) }}" style="height: 200px" /></td>
        </tr>
        <tr>
            <th>{{ trans('text.Employees') }}</th>
            <td>
                <?php foreach ($employees as $employee) { ?>
                    <a href="{{route('employees.show', $employee->id)}}"> {{ $employee->first_name }} {{ $employee->last_name }} <br/></a>
                <?php } ?>
            </td>
        </tr>
    </table>
@stop

@section('css')
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
    <link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/1.10.25/css/dataTables.bootstrap4.min.css">
@stop

@section('js')
    <script> console.log('Hi!'); </script>
    <script src="https://code.jquery.com/jquery-3.6.0.min.js" integrity="sha256-/xUj+3OJU5yExlq6GSYGSHk7tPXikynS7ogEvDej/m4=" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM" crossorigin="anonymous"></script>
    <script type="text/javascript" src="https://cdn.datatables.net/1.10.25/js/jquery.dataTables.min.js"></script>
    <script type="text/javascript" src="https://cdn.datatables.net/1.10.25/js/dataTables.bootstrap4.min.js"></script>
@stop

resources/views/companies/company-edit.blade.php
<!-- <link href="{{ asset('css/style.css') }}" rel="stylesheet"> -->
@extends('adminlte::page')

@section('title', trans('text.Edit') .  trans('text.Company'))

@section('content_header')
    <h1>{{ trans('text.Edit') }} {{ trans('text.Company') }}</h1>
@stop

@section('content')
    <html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
    <div class="container">
        <div class="row background">
            <div class="container">
                <div class="row">
                    <div class="col-md-12">
                        <form method="post" action="{{ route('companies.update', $company->id) }}" enctype="multipart/form-data">
                            
                            @csrf
                            @method('PATCH')
                            <div class="row mt-2">
                                <div class="col-md-4 text-left card-caption-home">{{ trans('text.Name') }}</div>
                                <div class="col-md-8">
                                    <input class="form-control" type="text" name="name" value="{{ $company->name }}"/>
                                </div>
                            </div>
                            <div class="row mt-2">
                                <div class="col-md-4 text-left card-caption-home">{{ trans('text.Email') }}</div>
                                <div class="col-md-8">
                                    <input class="form-control" type="text" name="email" value="{{ $company->email }}"/>
                                </div>
                            </div>
                            <div class="row mt-2">
                                <div class="col-md-4 text-left card-caption-home">{{ trans('text.Website') }}</div>
                                <div class="col-md-8">
                                    <input class="form-control" type="text" name="website" value="{{ $company->website }}"/>
                                </div>
                            </div>
                            <div class="row mt-2">
                                <div class="col-md-4 text-left card-caption-home">{{ trans('text.Domain') }}</div>
                                <div class="col-md-8">
                                    <input class="form-control" type="text" name="domain" value="{{ $company->domain }}"/>
                                </div>
                            </div>
                            <div class="row mt-2">
                                <div class="col-md-4 text-left card-caption-home">{{ trans('text.Logo') }}</div>
                                <div class="col-md-8">                                            
                                    <p>
                                        <img src="{{ asset('storage/'.$company->logo)}}" style="width:200px; object-fit: cover;"/>
                                    </p>
                                    <input type="file" name="filename">
                                    <br/><label>{{ trans('text.maxSize') }}: 2MB <br/> {{ trans('text.minDim') }}: 100 x 100 px</label>
                                </div>
                                <div class="col-md-4 text-left  card-caption-home"></div>
                                <div class="col-md-8">
                                    <button type="submit" class="btn btn-primary" style="margin-top:12px">{{ trans('text.Edit') }}</button>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>

@stop


@section('js')
    <script> console.log('Hi!'); </script>
@stop